import express from 'express';
import mongoose from 'mongoose';

import db from '../db';
import PredictionModel from '../models/prediction';

const router = express.Router();


router.post('/prediction/new', (req, res, next) => {
	console.log("New Prediction");
	console.log(JSON.stringify(req.body));
	new PredictionModel(req.body).save((err, data) => {
		if(err) return next(err);
		db.log(req, 'predictions', {_id: data._id}, data.toObject());
	});
});

router.post('/prediction/compare', async (req, res, next) => {
	const valA = await PredictionModel.findOne({ name: req.body.nameA });
	const valB = await PredictionModel.findOne({ name: req.body.nameB });
	if(!valA || !valB) next(new Error("invalid prediction name"));
	res.json(valB.value - valA.value);
});


module.exports = router;
